#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int N;
int mat1[1001][1001];		
int mat2[1001][1001];		
int mat3[1001][1001];		
int mat4[1001][1001];
char msg[1001][1001];

void rotate1 () {
	int i,j;	
	for (i=0; i<N;i++) {
		for(j=0;j<N;j++) {
			mat2[j][N-i-1] = mat1[i][j];
		}
	}
}

void rotate2 () {
	int i,j;	
	for (i=0; i<N;i++) {
		for(j=0;j<N;j++) {
			mat3[j][N-i-1] = mat2[i][j];
		}
	}
}

void rotate3 () {
	int i,j;	
	for (i=0; i<N;i++) {
		for(j=0;j<N;j++) {
			mat4[j][N-i-1] = mat3[i][j];
		}
	}
}




int main (int argc, char ** argv) {
	scanf("%d\n", &N);	
	while (N) {
		int i,j;		
		for (i=0;i<1001;i++) {
			for (j=0;j<1001;j++) {
				mat1[i][j] = mat2[i][j] = mat3[i][j] = mat4[i][j] = 0;
			}
		}
		
		for (i=0;i<N;i++) {
			for (j=0;j<N;j++) {
				char a;
				scanf("%c", &a);
				mat1[i][j] = (a == 'O') ? 1 : 0;
			}
			scanf("\n");
		}
		

		rotate1();
		rotate2();
		rotate3();
		
		
		for (i=0;i<N;i++) {
			scanf("%s", msg[i]);
		}

		for (i=0;i<N;i++) {
			for (j=0;j<N;j++) {
				if (mat1[i][j]) printf("%c", msg[i][j]);
			}
		}

		for (i=0;i<N;i++) {
			for (j=0;j<N;j++) {
				if (mat2[i][j]) printf("%c", msg[i][j]);
			}
		}

		for (i=0;i<N;i++) {
			for (j=0;j<N;j++) {
				if (mat3[i][j]) printf("%c", msg[i][j]);
			}
		}

		for (i=0;i<N;i++) {
			for (j=0;j<N;j++) {
				if (mat4[i][j]) printf("%c", msg[i][j]);
			}
		}
		printf("\n");

	scanf("%d\n", &N);
	}
	return 0;
}
