#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int N;
int POZ[6], ST[6];
int HR[1001];

int main (int argc, char ** argv) {
	scanf("%d\n", &N);	
	while (N) {
		int i;		
		for (i=0;i<5*N;i++) {
			int a;
			scanf("%d", &a);
			if (a<=6 && a >=1) {
				ST[a] = POZ[a] = i;
			} 
		}
		long long game = 1;
		int loop = 1;
		
		do {
			int j;
			for (j=1;j<6;j++) {			
				int h;			
				if (POZ[j] >= 4*N) 			h = POZ[j] % N;
				else if (POZ[j] >= 2*N) 	h = (POZ[j] - 2*N)/2;
				else 						h = POZ[j] / 2;
				HR[j] = h;			
			}
			
			if (HR[1] == HR[2] && HR[1] == HR[3] && HR[1] == HR[4] && HR[1] == HR[5]) {
				printf("Player %d wins game number %lld.\n", HR[1] + 1, game);
				loop = 0;				
				break;
			} else game++;	
			
			for (j=1;j<6;j++) {	
				if (POZ[j] == 2*HR[j]) 					POZ[j] = 5*HR[j];		
				else if (POZ[j] == 2*HR[j] + 1) 		POZ[j] = 5*HR[j]+1;		
				else if (POZ[j] == 2*HR[j] + 2*N)		POZ[j] = 5*HR[j]+2;		
				else if (POZ[j] == 2*HR[j] + 2*N + 1)	POZ[j] = 5*HR[j]+3;		
				else if (POZ[j] == HR[j] + 4*N)			POZ[j] = 5*HR[j]+4;		
			}

		} while(POZ[1] != ST[1] || POZ[2] != ST[2] || POZ[3] != ST[3] || POZ[4] != ST[4] || POZ[5] != ST[5]);
		
		if (loop) printf("Neverending game.\n");
	scanf("%d\n", &N);
	}
	return 0;
}
